;
; dolphindos.asm - DolphinDOS compatible parallel routines
;
; Written by
;  Kajtar Zsolt <soci@c64.rulez.org>
;
;    This file is part of IDEDOS the IDE64 disk operating system
;    See README for copyright notice.
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;

		.if (DOLPHINDOS_ACCEL=1)

iectalk		.proc			;ed09
		ora #$40
                .byte SKIP2
ieclisten	.proc			;ed0c
		ora #$20
                
ed11            .proc
                pha
                bit SerialOutBufFlag
                bpl jj
                sec
                ror $a3
                jsr ed40
                lsr SerialOutBufFlag
                lsr $a3
                lsr $a3			;<-Not JD!
jj              pla
                sta SerialOutBuf
                sei
                jsr f951
                
ed2e            .proc
                lda $dd00
                ora #$08
                sta $dd00

ed36		.proc
                sei
		jsr $ee8e		;clklo
		jsr $ee97		;datahi
		jsr $eeb3		;1ms delay
ed40            .proc
		sei
		jmp f96f
                .pend

iecsecond	.proc			;edb9
                jsr dolphout
		jmp $edbe		;atnhi
                .pend

iectksa		.proc			;edc7
                jsr dolphout
                sei
                bit $dc0c
                bpl if
                inc $dd03
if              jsr $eea0		;datalo
                jmp $edd0
                .pend

iecout		.proc
                bit SerialOutBufFlag
                bmi ir
                sec
                ror SerialOutBufFlag
                gmi zx

ir              pha
                jsr ed40
                pla
zx              sta SerialOutBuf
                clc
                rts
		.pend

iecuntalk	.proc
                sei
                jsr $ee8e		;clklo
                lda $dd00
                ora #$08
                sta $dd00
                lda #$5f
                .byte SKIP2

iecunlisten     .proc
                lda #$3f
                jsr ed11
                jmp $ee03
                .pend

f1b8		.proc
                lda $dd03
                sta $0296
                lda #$ff
                sta $dd03
                lda $dd01
                sta $0295
                rts
                .pend

iecin		.proc
		sei
                bit $dc0c
                bpl normal
                stx $a5
                bit $dd00
                bvc *-3
                lda $dd00
                and #$df
                sta $dd00
                ldx #$05
ii              bit $dd00
                bvc ke
                dex
                bne ii
                jsr $eea0		;datalo
                lda #$40
                jsr $fe1c		;set status
                jsr $ee97		;datahi
                ldx #$05
ii2             bit $dd00
                bvc ke
                dex
                bne ii2
                lda #$02
                gne f9b7

ke              ldx $dd01
                ora #$20
                sta $dd00
                stx SerialInBuf
                ldx $a5
                lda SerialInBuf
                clc
                cli
                rts

normal          lda #$00		;normal iecin
                sta $a5
		jsr $ee85		;clkhi
                jmp $ee1b
                .pend

dolphout       	.proc
		sta SerialOutBuf
                bit $dc0c
                bvs krk
                pha
                jsr ed36
                sei
                pla
                and #$f0
                cmp #$e0
                beq sd2
                stx $a5
                ldx #$19
                lda #$10
                bit $dd0d
ee              dex
                beq sd
                bit $dd01
                bit $dd0d
                beq ee
                asl $dc0c
                sec
                ror $dc0c
                jsr f1b8
sd              ldx $a5
sd2             cli
                rts

krk             and #$0f
                cmp #$07
                bne df
                lda #$43
;               gne ir

ir              sta $dc0c
df              gne f96f.f9b2
		.pend

f951		.proc
		bit $dc0c
                bvs f958
                bpl f958.ss

f958            .proc
		pha
                lda $dc0c
                and #$02
                sta $dc0c
                lda $0296
                sta $dd03
                lda $0295
                sta $dd01
                pla
ss              rts
		.pend
                
f96f		.proc			;dolphin iecout
                stx $a5
                lda $dc0c
                bpl f9bf
                lda $dd00
                bmi devicenotp
                and #$ef
                sta $dd00
                bit $a3
                bpl jd
                bit $dd00
                bpl *-3
                ldx #$1e
ce              lda $dd00
                bpl jd
                dex
                bne ce
                geq zc

jd              lda $dd00
                bpl jd
                ldx SerialOutBuf
                stx $dd01
                ldx #$1e
zc              ora #$10
                sta $dd00
                lda #$03		
cr              dex
                bmi f9b7                ;timeout
                bit $dd00
                bmi cr
kke             ldx $a5
f9b2            clc
                cli
                rts

devicenotp     	lda #$80

f9b7		.proc
		ldx $a5
		jsr f951
                jmp $edb2		;status

f9bf            .proc
		lsr a
                and #$20
                beq normal
                lda SerialOutBuf
                bcc kkf
                ldx #$0a
fw              dex
                cmp f0b3,x
                bcc fw
                sbc f19b,x
kkf
		sta $dd01
                bit $dd0d
                lda $dd00
                and #$fb
                sta $dd00
                ora #$04
                sta $dd00

                lda #$10
                bit $dd0d
                beq *-3
                gne f96f.kke

normal          jmp $ed44
		.pend

f0b3		.byte $00,$41,$5f,$61,$7f,$c0,$c1,$db,$e0,$ff
f19b		.byte $00,$e0,$00,$20,$00,$60,$80,$60,$40,$81

		.fi
