;
; fat.asm - FAT misc routines
;
; Written by
;  Kajtar Zsolt <soci@c64.rulez.org>
;
;    This file is part of IDEDOS the IDE64 disk operating system
;    See README for copyright notice.
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;

euiuei		= fatdirectory
euiuei2		= cluster2sector

fatdirectory	.proc
		.if SUPERCPU=1
		dec a
                .else
		dex
                .fi
		bne fatdir2
                ldx #15
lo              lda #32
                sta direntry_name_exp,x
                dex
                bpl lo
                jsr dir
                ldx #3
cy              lda ku,x
		sta direntry_pointer_exp,x
                sta direntry_size_exp,x
                dex
                bpl cy

                lda #FTYPE_DIR|FATTR_READ
                sta direntry_attrib_exp
		lda #DIRMODE_FAT2
		sta direntry_mode_exp
		lda #16
		sta direntry_number_exp
		rts
ku              .byte $40,0,0,1

fatdir2		ldx #240
cb23		lda data_g		;Get name ($02)
		#lda_low_reg
		sta direntry_name_exp-240,x
		inx
		lda hig_reg
		sta direntry_name_exp-240,x
		inx
		bne cb23

		ldx #2
lu              lda direntry_name_exp+8,x
                sta direntry_filetype_exp,x
                dex
                bpl lu

		ldx #248
		lda direntry_name_exp
                bne noo
                sta next_sector
                sta next_sector+1	;last sector
                sta next_sector+2	;no check for maximal direntry sector count reached!!!!!!!
                sta next_sector+3
                geq no

noo             cmp #$e5
                beq longnone
                cmp #$05
                bne *+4
                lda #$e5
                sta direntry_name_exp

                lda direntry_name_exp+11;00ADVSHR
                cmp #$0f
                beq longnone
                lsr	;r
                php
                lsr	;h
                lsr	;s
                lsr	;v
                php
                lsr	;d
		lda #FATTR_EXEC | FTYPE_NORMAL | FATTR_READ
                bcc nok

		jsr dir
		ldx #248+3

                lda #FATTR_EXEC | FTYPE_DIR | FATTR_READ
nok             plp
        	bcs *+4
                ora #FATTR_CLOSED
ko        	plp
        	bcs *+4
                ora #FATTR_WRITE | FATTR_DELETE
                .byte SKIPLDA0
longnone	#lda0
no		sta direntry_attrib_exp

                lda direntry_name_exp+11;00ADVSHR
                lsr	;r
                lsr	;h
                #lda0
                ror			;hidden
                sta direntry_pointer_exp

                lda #32
nu              sta direntry_name_exp-240,x
		inx
                bne nu
                
                bit data_g		;cdate
                bit data_g              ;adate

                lda data_g
                #lda_low_reg
                sta direntry_pointer_exp+1
                lda hig_reg
                and #$0f
                ora direntry_pointer_exp+0
                sta direntry_pointer_exp+0

                bit data_g		;mtime
                bit data_g		;mdate

                lda data_g
                #lda_low_reg
                sta direntry_pointer_exp+3
                lda hig_reg
                sta direntry_pointer_exp+2
                .if FAST_DATA_TRANSFERS=1
                ora direntry_pointer_exp+3
                .else
                ora low_reg
                .fi
                ora direntry_pointer_exp+1
		bne jd
                lda direntry_pointer_exp
                and #$0f
                bne jd
                tay
                #ldx_l_a partition_currentp_exp
yyy             lda partition_root_dir_exp,x
                #sta_l_y_ direntry_pointer_exp
                inx
                iny
                cpy #4
                bcc yyy

jd              ldx #252
aj		lda data_g
                #lda_low_reg
                sta direntry_size_exp-252,x
                inx
                lda hig_reg
                sta direntry_size_exp-252,x
                inx
                bne aj

                ldx #15
                #txy_a
                jsr killpad

		lda direntry_number_exp
                bne tp
                
                lda next_sector
		ora next_sector+1
		ora next_sector+2
		ora next_sector+3
                beq tp

                #inc_l_a direntry_fat_dirsectors_exp
                
                jsr sector2cluster
                bcc rootd
                
                lda next_sector+3
                cmp #2
                bcs nk
                lda next_sector+2
                ora next_sector+1
                ora next_sector
                bne nk
rootd           ldx #1
                stx next_sector+3
                dex
                stx next_sector+2
                stx next_sector+1
                stx next_sector
                geq tp

nk      	#ldx_l_a partition_currentp_exp
                lda direntry_fat_dirsectors_exp
                eor partition_fat_sectperclust_exp,x
                bne tp
                sta direntry_fat_dirsectors_exp

                jsr XIT_nomoreread	;-=> error

                jsr XIT_nextcluster
tp                
                ldx #direntry_filetype_exp-direntry_name_exp+2
                ldy #3
                
killpad         lda direntry_name_exp,x
                eor #$20
                bne njo
                sta direntry_name_exp,x
                dex
                dey
                bne killpad
njo		rts

dir             ldx #2
hh              lda dirtxt,x
                sta direntry_filetype_exp,x
                dex
                bpl hh
		rts
dirtxt		.text "dir"
		.pend

cluster2sector	.proc
		pha
                lda next_sector+3
                eor #1
                ora next_sector+2
                ora next_sector+1
                ora next_sector
                bne nrootdir
                lda partition_currentp_exp
                ora #3
                tax
                pla
                ldy #3
                clc
                .byte SKIPLDA0
ge              #lda0
                adc partition_fat_root_dir_exp,x
                sta next_sector,y
                dex
                dey
                bpl ge
                ldx #4
te      	lda szam,x
                pha
                dex
                bpl te
                gmi ou

nrootdir       	lda partition_currentp_exp
                ora #3
                tay
                
                #lda_l_y_x partition_fat_sectperclust_exp-3
iiu             lsr
                beq bbb
                ldx #3
xf              rol next_sector,x
                dex
                bpl xf
                gmi iiu
bbb

		pla
                ora next_sector+3
                sta next_sector+3

		#tyx_a

		lda szam+4
                pha
                ldy #3
                clc
le              lda szam,y
        	pha
		lda next_sector,y
		adc partition_fat_data_exp,x
                sta next_sector,y
                dex
                dey
                bpl le
ou
                ldx #3
                ldy #0
tte             lda next_sector,x
                sta szam,y
                iny
                dex
                bpl tte

                jsr fatlba2chs

		ldx #0
xn2             pla
        	sta szam,x
                inx
                cpx #5
                bne xn2
		rts
                .pend

sector2cluster	.proc
                ldx #4
le              lda szam,x
        	pha
                dex
                bpl le

                jsr chs2lba
                lda szam+3
                and #$0f
                pha

                ldx #2
hu              lda szam,x
                pha
                dex
                bpl hu

		lda partition_currentp_exp
                ora #3
                tax

		ldy #3
                sec
tte             pla
                sbc partition_fat_data_exp,x
                sta next_sector,y
                dex
		dey
                bpl tte
                php

		inx
                lda partition_fat_sectperclust_exp,x
iiu             lsr
                beq bbb
                lsr next_sector
                ror next_sector+1
                ror next_sector+2
                ror next_sector+3
                #jmps iiu
bbb
		plp
		ldx #0
                ldy #5
xn2             pla
        	sta szam,x
                inx
                dey
                bne xn2
		rts
                .pend

XIT_nextcluster	.proc
		lda partition_currentp_exp
                ora #3
                tax
                lda partition_fat_type_exp-3,x
                beq fat32
                cmp #1
                beq fat16
                gne fat12

fat32           asl next_sector+3       ;fat32
		rol next_sector+2
		rol next_sector+1
		rol next_sector
                
                lda next_sector+3
                pha
                
		ldy #3
                clc
lue3            tya
		beq tit
		lda next_sector-1,y
tit             adc partition_fat_fat_exp,x
                sta next_sector,y
                dex
                dey
                bpl lue3
                
                jsr readfat0

                pla
                asl
                tax
                
                ldy #3
lloe            jsr getfat
                sta next_sector,y
                inx
                dey
                bpl lloe
                and #$0f
                sta next_sector
                rts

fat16   	lda next_sector+3
		pha
		lda next_sector+2	;fat16
		ldy #3
                clc
                .byte SKIPLDA0
lue2            #lda0
                adc partition_fat_fat_exp,x
                sta next_sector,y
                dex
                dey
                bpl lue2

                jsr readfat0

		pla
                asl
                tax

		jsr getfat
		sta next_sector+3
		inx
		jsr getfat
		sta next_sector+2
		rts

fat12	  	lda next_sector+2	;fat12
                lsr
		tay
		lda next_sector+3
                ror
                php

		clc
                adc next_sector+3
                pha
                tya
                adc next_sector+2
                ror
                php
                
                ldy #3
                clc
                .byte $2c
lue             lda #0
                adc partition_fat_fat_exp,x
                sta next_sector,y
                dex
                dey
                bpl lue

                jsr readfat0

                plp
                pla
                tax

		jsr getfat
		sta next_sector+3

                inx
                bne nni
                bcc nni2

		sec
		jsr readfat

                clc
                ldx #0
                .byte $24
nni2		sec

nni             jsr getfat

                plp
                bcs odd
                and #$0f
                gcc nnk
odd
		ldx #4
nk              lsr a
                ror next_sector+3
                dex
                bne nk
nnk		sta next_sector+2
		rts

getfat		lda ram_fat_exp,x
		bcc ti
                lda ram_fat_exp+$100,x
ti		rts

readfat0	clc
readfat		ldx #end_zeropage-start_zeropage-1
le              lda start_zeropage,x
        	pha
                dex
                bpl le

                ldx #3
                ldy #0
tte             #lda0
                adc next_sector,x
		sta szam,y
                iny
                dex
                bpl tte

		jsr fatlba2chs

		lda #ram_exp_fat
                jsr XIT_read_a_sector
                
		ldx #0
xn2             pla
        	sta start_zeropage,x
                inx
                cpx #end_zeropage-start_zeropage
                bne xn2
		rts
		.pend

fatlba2chs     	.pend
		#ldx_l_a current_drive_exp
		lda drive_lba_exp,x
                #orasta_a szam+3
                jmp lba2chs
		.pend
