;
; man2.asm - File manager out of memory part ;)
;
; Written by
;  Kajtar Zsolt <soci@c64.rulez.org>
;
;    This file is part of IDEDOS the IDE64 disk operating system
;    See README for copyright notice.
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;

;---------------------------
; Screen input
;
clrinput_	.proc
		stx m_p1
                pha
                tax
                #lda0
ld              sta man_input,x
                dex
                bpl ld
                pla
                ldx m_p1

input_		.proc
maxlen		= m_p2
cpos		= m_p2+1
first		= m_p3

		stx m_p1
                stx m_p4
		sty m_p1+1
		sta maxlen
                tya
                eor #$d8^$04
                sta m_p4+1
		#stz_a cpos
		lda #192
		sta first

lp		asl first
		ldy #0
r		ldx man_input,y
		bne *+4
		ldx #32
		lda cconv,x
		sta (m_p1),y
                lda manager_input_color
                sta (m_p4),y
		iny
		cpy maxlen
		bne r

		ldy cpos
		ldx #0

lp1		lda $d011
		bpl *-3
		lda $d011
		bmi *-3
		dex
		bpl l
		ldx #16
		lda (m_p1),y
		eor #128
		sta (m_p1),y
l		lda 198
		beq lp1
		lda 631
		dec 198

;       	cmp #","
;       	beq lp
;       	cmp #":"
;       	beq lp
		cmp #"="
		beq lp

		cmp #20			;del
		bne n1
		tya
		beq lp
		iny
		cpy maxlen
		bne y
		lda man_input-1,y
		beq y
ld		#lda0
		sta man_input-1,y
		geq lp
y		dey
lp2		lda man_input,y
		sta man_input-1,y
		iny
		cpy maxlen
		bcc lp2
		dec cpos
		gcs ld

n1
		cmp #157		;left
		bne n2
		tya
		beq lp
		dec cpos
lpx		#jmps lp
n2
		cmp #29			;right
		bne n3
jobb		iny
		cpy maxlen
		beq lpx
		lda man_input-1,y
		beq lpx
		sty cpos
                gne lpx
lpu
n3
		cmp #133
                beq home
		cmp #19
		bne n4
home		#stz_a cpos
		geq lp
n4
		cmp #136
                bne dj
                ldy maxlen
jd              dey
                lda man_input,y
                beq jd
                sty cpos
                gne jobb
                
dj		cmp #147
		bne n5
		#lda0
		ldx maxlen
lh		sta man_input,x
		dex
		bpl lh
		sta cpos
		gmi lp
n5
		cmp #148
		bne n6
		ldy maxlen
		lda man_input-1,y
		bne lpx
t		dey
		cpy cpos
		beq py
		lda man_input-1,y
		sta man_input,y
		#jmps t
py		lda #32
		sta man_input,y
		gne lp

n6
		cmp #3
		beq exit
		cmp #13
		beq exit

		ldx first
		beq ig
		pha
		ldx maxlen
		#lda0
li		sta man_input,x
		dex
		bpl li
		pla

ig		sta man_input,y
		#jmps jobb

exit		cmp #3
		rts
		.pend
;---------------------------
; Print decimal number
;
numtoasc16_	.proc
		stx m_ascii+4
		sta m_ascii+5
		#stz_a m_ascii+1
		#stz_aa m_ascii+2
		#stz_aa m_ascii+3

		ldy #16
		php
		sei
		sed
p2		asl m_ascii+4
		rol m_ascii+5
		ldx #2
p		lda m_ascii+1,x
		adc m_ascii+1,x
		sta m_ascii+1,x
		dex
		bpl p
		dey
		bne p2
		plp
		ldx #133
		gne numtoasc24_.in

numtoasc24_	.proc
		stx m_ascii+4
		sta m_ascii+5
		sty m_ascii+6
		#stz_a m_ascii
		#stz_aa m_ascii+1
		#stz_aa m_ascii+2
		#stz_aa m_ascii+3

		ldy #24
		php
		sei
		sed
p2		asl m_ascii+4
		rol m_ascii+5
		rol m_ascii+6
		ldx #3
p		lda m_ascii,x
		adc m_ascii,x
		sta m_ascii,x
		dex
		bpl p
		dey
		bne p2
		plp
		ldx #135

		lda (m_p2),y
                and #128
                sta m_ascii+4

		lda m_ascii
		jsr h
in		lda m_ascii+1
		jsr h
		lda m_ascii+2
		jsr h
		lda m_ascii+3

h		pha
		lsr
		lsr
		lsr
		lsr
		jsr aa
		pla
aa		and #15
		bne r2
		dex
		bmi r
r2		ora #$30
		tax
                ora m_ascii+4
		sta (m_p2),y
		iny
r		rts
		.pend

man_printfullfree_ .proc
		ldy selectedwin
		lda man_fullfree,y
		cmp #"f"
		beq *+3
		clc

		ldy #39
		ldx #4
ig		lda fullbar-1,x
		bcc if
		lda freebar-1,x
if		eor m_d018
		sta (m_p2),y
		iny
		dex
		bne ig
		rts

fullbar		.byte "DESU"
freebar		.byte "EERF"
                .pend

scrollbar_	.proc
		lda #<$494
		ldy #>$494
		ldx selectedwin
		beq *+6
		lda #<$674
		ldy #>$674
		sta m_p2
		sty m_p2+1

		lda man_files_l,x
		sec
		sbc #1
		sta m_p3
		lda man_files_h,x
		sbc #0
		sta m_p3+1
		ora m_p3
		bcc e
		beq e
		lda man_el_l,x
		clc
		adc man_bar,x
		sta m_p1
		#lda0
		adc man_el_h,x
		asl m_p1
		rol
		asl m_p1
		rol
		asl m_p1
		rol
		sta m_p1+1

cg2		sec
cg		lda m_p1
		sbc m_p3
		sta m_p1
		lda m_p1+1
		sbc m_p3+1
		sta m_p1+1
		bcc e

		lda m_p2
		adc #40-1
		sta m_p2
		bcc cg2
		inc m_p2+1
		gcs cg

e		lda man_oldsc_l,x
		ldy man_oldsc_h,x
		beq nn
		cmp m_p2
		bne n
		cpy m_p2+1
		beq ni
n		sta m_p3
		sty m_p3+1
		ldy #0
		lda #221
		sta (m_p3),y
nn		lda #64			;186
		sta (m_p2),y
		lda m_p2
		sta man_oldsc_l,x
		lda m_p2+1
		sta man_oldsc_h,x
ni		rts
		.pend
